﻿package galileu
{
	import flash.display.MovieClip;
	import flash.geom.Point;
	
	public class Ramp extends MovieClip
	{
		private var spStructure:SimplePolygon;
		private var vertexes:Array;
		private var cBall:Circle;
		private var myWidth:Number;
		private var myHeight:Number;
		
		public function Ramp()
		{
			spStructure = new SimplePolygon();
			spStructure.setFilled(true);
			vertexes = [new Point(0, 0), new Point(0, 0), new Point(0, 0)];
			addChild(spStructure);
		}
		
		public function getWidth():Number
		{
			return myWidth;
		}
		
		public function getHeight():Number
		{
			return myHeight;
		}
		
		public function reinit():void
		{
			cBall.x = 0;
			cBall.y = -cBall.getRadius();
		}
		
		public function getBall():Circle
		{
			return cBall;
		}
		
		public function setBall(_ball:Circle):void
		{
			cBall = _ball;
			reinit();
			addChild(_ball);
		}
		
		public function build(_myWidth:Number, _myHeight:Number, _color:uint = 0xCEB27E):void
		{
			myWidth = _myWidth;
			myHeight = _myHeight;
			vertexes[1].x = _myWidth;
			vertexes[1].y = _myHeight
			vertexes[2].y = _myHeight;
			spStructure.setVertexes(vertexes);
			spStructure.setFillColor(_color);
			spStructure.drawMe();
		}
	}
}