﻿package galileu
{
	import flash.geom.Point;
	import flash.display.MovieClip;
	
	public class SimplePolygon extends MovieClip
	{
		protected var vertexes:Array;
		protected var fillColor:uint;
		protected var filled:Boolean;
		protected var thickness:Number;
		
		public function SimplePolygon()
		{
			vertexes = new Array();
			fillColor = 0xFFFFFF;
			thickness = 1;
			filled = false;
		}
		
		public function setThickness(_thickness:Number):void
		{
			thickness = _thickness;
		}
		
		public function setVertexes(_vertexes:Array):void
		{
			vertexes = _vertexes;
		}
		
		public function setFillColor(_fillColor:uint):void
		{
			fillColor = _fillColor;
		}
		
		public function setFilled(_filled:Boolean):void
		{
			filled = _filled;
		}
		
		public function getThickness():Number
		{
			return thickness;
		}
		
		public function getVertexes():Array
		{
			return vertexes;
		}
		
		public function getFillColor():uint
		{
			return fillColor;
		}
		
		public function isFilled():Boolean
		{
			return filled;
		}
		
		public function addVertex(_vertex:Point):void
		{
			vertexes.push(_vertex);
		}
		
		public function drawMe():void
		{
			graphics.clear();
			var i:Number;
			var vertice:Point = vertexes[0];
			this.graphics.lineStyle(thickness, 0x000000, 1.0);
			
			if (filled)
				this.graphics.beginFill(fillColor);
				
			this.graphics.moveTo(vertice.x, vertice.y);
			
			for (i = 1; i < vertexes.length; i++) {
				vertice = vertexes[i];
				this.graphics.lineTo(vertice.x, vertice.y);
			}
			vertice = vertexes[0];

			this.graphics.lineTo(vertice.x, vertice.y);
			
			if (filled)
				this.graphics.endFill();
		}
	}
}