﻿package fita
{
	import flash.display.MovieClip;
	import flash.geom.Point;
	import flash.geom.Matrix;
	
	public class Straight extends MovieClip
	{
		public static const NORMAL:int = 0;
		public static const DOTTED:int = 1;
		
		public static const DEFAULT_THICKNESS:Number = 1;
		public static const DEFAULT_COLOR:uint = 0x000000;
		
		private var angle:Number;
		private var initialPoint:Point;
		private var finalPoint:Point;
		private var myWidth:Number;
		private var thickness:Number;
		private var myColor:uint;
		private var type:int;
		private var dottedDistance:Number;
		private var dottedGapDistance:Number;
		
		public function Straight()
		{
			thickness = DEFAULT_THICKNESS;
			myColor = DEFAULT_COLOR;
			type = NORMAL;
			dottedDistance = 5;
			dottedGapDistance = 5;
		}
		
		public function setType(_type:int):void
		{
			type = _type;
		}
		
		public function getType():Number
		{
			return type;
		}
		
		public function setColor(_color:uint):void
		{
			myColor = _color;
		}
		
		public function getColor():uint
		{
			return myColor;
		}
		
		public function setThickness(_thickness:Number):void
		{
			thickness = _thickness;
		}
		
		public function setAngle(_angle:Number):void
		{
			angle = _angle;
		}
		
		public function getAngle():Number
		{
			return angle;
		}
		
		public function setInitialPoint(_initialPoint:Point):void
		{
			initialPoint = _initialPoint;
		}
		
		public function getInitialPoint():Point
		{
			return initialPoint;
		}
		
		public function getFinalPoint():Point
		{
			return finalPoint;
		}
		
		public function setFinalPoint(_finalPoint):void
		{
			finalPoint = _finalPoint;
		}
		
		public function setWidth(_myWidth:Number):void
		{
			myWidth = _myWidth;
		}
		
		public function getWidth():Number
		{
			return myWidth;
		}
		
		public function getDistance():Number
		{
			return Point.distance(initialPoint, finalPoint);
		}
		
		public function drawMe():void
		{
			this.graphics.clear();
			
			var auxiliarPoint:Point;
			
			this.graphics.lineStyle(thickness, myColor, 1.0);
			this.graphics.moveTo(initialPoint.x, initialPoint.y);
			switch (type)
			{
				case DOTTED:
					var centerPoint:Point = initialPoint;
					var distance:Number = (initialPoint.x < finalPoint.x) ? dottedDistance : -dottedDistance;
					var gapDistance:Number = (initialPoint.x < finalPoint.x) ? dottedGapDistance : -dottedGapDistance;
					auxiliarPoint = new Point(initialPoint.x + distance, initialPoint.y);
					var rotatedPoint:Point;
					var angle:Number = MyMath.getAngle([new Point(initialPoint.x + 5, initialPoint.y), centerPoint],
													   [centerPoint, finalPoint]); // ângulo entre o eixo x e a reta
					var matrix:Matrix = new Matrix();
					matrix.identity();
					matrix.rotate(MyMath.convertDegreeToRadian(angle));
					rotatedPoint = centerPoint.add(matrix.transformPoint(auxiliarPoint.subtract(centerPoint)));
					
					var auxiliaryAngle:Number = MyMath.getAngle([centerPoint, rotatedPoint],
													   [rotatedPoint, finalPoint]);
					while (Comparator.equalAnglesWithError(auxiliaryAngle, 180))
					{
						this.graphics.lineTo(rotatedPoint.x, rotatedPoint.y);
						auxiliarPoint.x += gapDistance;
						rotatedPoint = centerPoint.add(matrix.transformPoint(auxiliarPoint.subtract(centerPoint)));
						
						this.graphics.moveTo(rotatedPoint.x, rotatedPoint.y);
						auxiliarPoint.x += distance;
						rotatedPoint = centerPoint.add(matrix.transformPoint(auxiliarPoint.subtract(centerPoint)));
						
						auxiliaryAngle = MyMath.getAngle([centerPoint, rotatedPoint],
													   [rotatedPoint, finalPoint]);
					}
					break;
			}
			
			this.graphics.lineTo(finalPoint.x, finalPoint.y);
		}
	}
}