﻿package fita
{
	import flash.display.MovieClip;
	import flash.geom.Point;
	
	public class TapeSide extends MovieClip
	{
		protected var innerCircle:Circle;
		protected var outerCircle:Circle;
		protected var line:Straight;
		protected var maxRay:Number;
		
		public function TapeSide()
		{
			maxRay = 60;
			
			outerCircle = new Circle();
			outerCircle.setColor(0x000000);
			outerCircle.setRadius(maxRay);
			addChild(outerCircle);
			
			innerCircle = new Circle();
			innerCircle.setColor(0xF2F2F2);
			innerCircle.setRadius(20);
			addChild(innerCircle);
			
			line = new Straight();
			line.setInitialPoint(new Point(0, 0));
			line.setFinalPoint(new Point(0, -50));
			initLinePosition();
			addChild(line);
		}
		
		public function updateLine():void
		{
			line.setInitialPoint(getLineCoordinate());
			line.drawMe();
		}
		
		protected function getLineCoordinate():Point
		{
			return null;
		}
		
		public function reinit(_initialRay:Number = 60 /* = maxRay */):void
		{
			outerCircle.width = 2 * _initialRay;
			outerCircle.height = 2 * _initialRay;
			outerCircle.setRadius(_initialRay);
			outerCircle.drawMe();
			
			line.setInitialPoint(new Point(0, 0));
			line.setFinalPoint(new Point(0, -50));
			initLinePosition();
			updateLine();
			line.drawMe();
		}
		
		public function getInnerRadius():Number
		{
			return innerCircle.getRadius();
		}
		
		public function getOuterCircle():Circle
		{
			return outerCircle;
		}
		
		public function setInnerRadius(_radius:Number):void
		{
			innerCircle.setRadius(_radius);
		}
		
		public function setInnerColor(_color:uint):void
		{
			innerCircle.setColor(_color);
		}
		
		public function setOuterRadius(_radius:Number):void
		{
			outerCircle.setRadius(_radius);
		}
		
		public function setOuterColor(_color:uint):void
		{
			outerCircle.setColor(_color);
		}
		
		public function initLinePosition():void
		{
		}
		
		public function drawMe():void
		{
			outerCircle.drawMe();
			innerCircle.drawMe();
			line.drawMe();
			updateLine();
		}
	}
}